#!/bin/bash
# --------------------------------------------------------------
# | This is a fairly brain-dead, brute-force make script; if   |
# | anyone who's a gmake whiz wants to re-write it as a proper |
# | makefile, have at it ...                                   |
# --------------------------------------------------------------



# --------------------------------------------------------------
# | Figure out what to build                                   |
# --------------------------------------------------------------
if [ $# = 0 ]; then
    mk_gtwy=1
    mk_mod=1
    mk_lbpi=
else
    for i; do
        case $i in
            gateway|wine_perl_gateway|gtwy)  mk_gtwy=1;;
            wine_module|wine_mod|module|mod) mk_mod=1;;
            lbpi)                            mk_lbpi=1;;
            all)                             mk_gtwy=1
                                             mk_mod=1
                                             mk_lbpi=1;;
        esac
    done
fi


# --------------------------------------------------------------
# | If WINE_ROOT directory not specified, take some guesses    |
# --------------------------------------------------------------
function is_wine_dir
{
    typeset d=$1

    if [ -f $d/include/winbase.h         ] &&
       [ -x $d/tools/winebuild/winebuild ] &&
       [ -f $d/dlls/libkernel32.so       ]
    then
        return 0
    else
        return 1
    fi
}
if [ -z $WINE_ROOT ]; then
    if is_wine_dir ~/wine; then
        export WINE_ROOT=~/wine
    elif is_wine_dir ~wine; then
        export WINE_ROOT=~wine
    fi
fi
if [ -z $WINE_ROOT ]; then
    echo "Can't find wine directory"
    exit 1
elif ! is_wine_dir $WINE_ROOT; then
    echo "[$WINE_ROOT] not a valid wine directory"
    exit 1
fi
echo "WINE_ROOT [$WINE_ROOT]"


# --------------------------------------------------------------
# | Default value for wine/perl gateway lib                    |
# --------------------------------------------------------------
[ -z $WINE_PERL_GATEWAY ] && export WINE_PERL_GATEWAY=$PWD/wine_perl_gateway
echo "WINE_PERL_GATEWAY [$WINE_PERL_GATEWAY]"


# --------------------------------------------------------------
# | Clean up previous builds                                   |
# --------------------------------------------------------------
find . -name '*.o' -exec rm {} \;


# --------------------------------------------------------------
# | Build wine_perl_gateway lib                                |
# --------------------------------------------------------------
if [ $mk_gtwy ]; then
    (
        typeset f=wine_perl_gateway
        echo "[$f]"

        function compile
        {
            typeset f=$1
            gcc -c -o $f.o                \
                -I $WINE_ROOT/include     \
                -g                        \
                -Wno-switch               \
                -O0 -Wall                 \
                -DWINELIB                 \
                -DSTRICT                  \
                -D_REENTRANT              \
                -o $f.o                   \
                $f.c             
        }

        cd wine_perl_gateway
        $WINE_ROOT/tools/winebuild/winebuild -fPIC -o $f.spec.c -spec $f.spec
        compile $f.spec
        compile $f
        gcc -o lib$f.so -shared $f.o $f.spec.o -L $WINE_ROOT/dlls -lkernel32
    )
fi


# --------------------------------------------------------------
# | Build wine perl module                                     |
# --------------------------------------------------------------
if [ $mk_mod ]; then
    (
        cd wine            &&
        echo "[wine mod]"  &&
        perl Makefile.PL   &&
        make
    )
fi


# --------------------------------------------------------------
# | Build little-bitty perl interpreter                        |
# --------------------------------------------------------------
if [ $mk_lbpi ]; then
    echo "[lbpi]"
    gcc -o tools/lbpi tools/lbpi.c                      \
        $(perl -MExtUtils::Embed -e ccopts -e ldopts)   \
        wine/blib/arch/auto/wine/wine.so                \
        -L wine_perl_gateway -lwine_perl_gateway        \
        -Wl,-rpath $WINE_ROOT/dlls    
fi


# --------------------------------------------------------------
# | Done                                                       |
# --------------------------------------------------------------
exit
